﻿using System.Windows;
using Telerik.Windows;
using Telerik.Windows.Controls;
using System.Collections.Generic;

namespace GridViewInComboBox
{
	public class ComboBoxExtensions
	{
		public static bool GetEnableInnerGridView(DependencyObject obj)
		{
			return (bool)obj.GetValue(EnableInnerGridViewProperty);
		}

		public static void SetEnableInnerGridView(DependencyObject obj, bool value)
		{
			obj.SetValue(EnableInnerGridViewProperty, value);
		}

		public static readonly DependencyProperty EnableInnerGridViewProperty =
			DependencyProperty.RegisterAttached("EnableInnerGridView", typeof(bool), typeof(ComboBoxExtensions),
			new System.Windows.PropertyMetadata(InitializeGridView));

		private static void InitializeGridView(DependencyObject d, DependencyPropertyChangedEventArgs args)
		{
			RadComboBox combo = d as RadComboBox;
			if (combo != null)
			{
				combo.AddHandler(GridViewExtensions.SelectionChangedEvent, new RadRoutedEventHandler(
					delegate(object sender, RadRoutedEventArgs e)
					{
						RadGridView grid = e.OriginalSource as RadGridView;
						if (grid != null)
						{
							combo.SelectedItem = grid.SelectedItem;
							combo.IsDropDownOpen = false;
						}
					}));
			}
		}
	}
}